#include <stdlib.h>
#include <stdio.h>
#include <string>
#include <queue>
#include <map>
using namespace std;
struct PZ {char s[11]; int e; int d; vector<int> m;};
queue<PZ> Q;
map<string, int> M;

int cmp( int m, int n ){ return m==n?0:1; }

PZ move( PZ x, int k ){
	PZ t=x;
	int now=t.e, next;
	
	if( k==0 && now>=4 ) next=now-3;
	else if( k==1 && now<=6 ) next=now+3;
	else if( k==2 && now%3!=1 ) next=now-1;
	else if( k==3 && now%3!=0 ) next=now+1;
	else next=now;
	
	if(next!=now){
		t.d -= cmp(t.s[next]-'0', next);
		t.d += cmp(t.s[next]-'0', now);
		swap(t.s[now], t.s[next]);
		t.e=next;
		t.m.push_back(k);
	}
	
	return t;
}

void bfs(){
	PZ t, tt;
	
	char MOVE[5]="UDLR";
	
	while(!Q.empty()){
		t=Q.front();
		Q.pop();
	
		if(t.d==0){
			printf("Solved!\n\n");
			for(int i=0;i<t.m.size();i++){
				printf("%c ", MOVE[t.m[i]]);
				if((i+1)%4==0) printf("\n");
			}
			printf("\n");
			return;
		}else{
			for(int i=0;i<=3;i++){
				tt=move(t,i);
				if(M[tt.s] !=1){
					M[tt.s]=1;
					Q.push(tt);
				}
			}
		}
	}
}
int main(){
	PZ t;
	t.d=0;
	
	printf("input 8puzzle's number\n");
	t.s[0]='#';
	
	for(int i=1,n; i<=9;i++){
		scanf("%d",&n);
		if(n==0) t.e=i;
		else t.d+=cmp(n,i);
		t.s[i]=n+'0';
	}
	t.s[10]='\0';
	
	printf("\n BFS started..");
	
	Q.push(t);
	M[t.s]=1;
	bfs();
	system("pause");
	return 0;

}

